<template>
  <div class="block-content">
    <form>
      <div class="form-content">
        <label class="form-label">Country</label>
        <input type="text" class="form-value" id="country"
        v-model="country.country"/>
      </div>
      <div class="err" id="country-err">
        <p style="color: red;">Country name shouldn't contain numbers
          or being empty!
        </p>
      </div>
      <div class="form-content">
        <label class="form-label">Alfa-2</label>
        <input type="text" class="form-value" id="alfa" v-model="country.alfa2"/>
      </div>
      <div class="err" id="alfa-err">
        <p style="color: red;">Alfa 2 code shouldn't contain numbers,
          being empty or have more than 2 characters</p>
      </div>
      <div class="form-content">
        <input type="button" value="Submit and new" class="form-button"
        v-on:click="submit('Country')" />
        <input type="button" value="Submit" class="form-button"
        id="righter" v-on:click="submit('Countries')" />
      </div>
    </form>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'Country',
  props: {
    object: Number,
  },
  data() {
    return {
      country: {},
    };
  },
  mounted() {
    this.get();
  },
  methods: {
    get() {
      if (this.object > 0) {
        axios.get(`http://localhost:4000/api/countries/${this.object}`)
          .then((response) => {
            this.country = response.data;
          })
          .catch((e) => {
            console.log(e);
          });
      }
    },
    validateCountry(obj) {
      const reg = /.*\d.*/;
      if (obj.country && obj.alfa2.length === 2
        && !reg.test(obj.country) && !reg.test(obj.alfa2)) {
        return true;
      }
      if (!obj.country || reg.test(obj.country)) {
        document.getElementById('country').style.borderColor = 'red';
        document.getElementById('country-err').style.display = 'block';
      }
      if (obj.alfa2.lenght !== 2 || reg.test(obj.alfa2)) {
        document.getElementById('alfa').style.border = 'red';
        document.getElementById('alfa-err').style.display = 'block';
      }

      return false;
    },
    submit(component) {
      if (this.object === 0) {
        if (this.validateCountry(this.country)) {
          axios.post('http://localhost:4000/api/countries', {
            country: this.country.country,
            alfa2: this.country.alfa2,
          })
            .then((response) => { console.log(response); alert('sukcesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
        }
        this.nullify();
      } else {
        if (this.validateCountry(this.country)) {
          axios.patch(`http://localhost:4000/api/countries/${this.object}`, {
            country: this.country.country,
            alfa2: this.country.alfa2,
          })
            .then((response) => { console.log(response); alert('succesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
        }
        this.$emit('change-component', component);
        this.$emit('object', 0);
      }
    },
    nullify() {
      document.getElementById('alfa').value = '';
      document.getElementById('country').value = '';
    },
  },
};
</script>

<style scoped>
@import "../CSS/actionObject.css";
</style>
